# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with bootstrap
%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free
%define cvsversion 20050722 

Name:           msv
Version:        1.2
Release:        0.%{cvsversion}.7%{?dist}
Epoch:          0
Summary:        Multischema Validator
License:        BSD-style
Group:          Text Processing/Markup/XML
URL:            http://msv.dev.java.net
Source0:        msv-20050722.tar.gz
Source1:        msv.pom
Source2:        xsdlib.pom
Patch0:         msv-msv-build_xml.patch
Patch1:         msv-relames-build_xml.patch
Patch2:         msv-xsdlib-build_xml.patch
Patch3:         msv-xmlgen-build_xml.patch
# Backported from CVS tip; can go away with an update
# Allow compilation with JDK 1.5
Patch4:         msv-jdk15.patch
Patch5:         msv-nocrimson.patch
Provides:       msv-msv = %{epoch}:%{version}-%{release}
Provides:       msv-strict = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       isorelax
Requires:       jpackage-utils
Requires:       relaxngDatatype
Requires:       servletapi5
Requires:       xerces-j2
Requires:       xml-commons-jaxp-1.3-apis
Requires:       xml-commons-resolver11
Requires:       msv-xsdlib
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant
BuildRequires:  javacc
BuildRequires:  junit
%if %without bootstrap
BuildRequires:  jdom
BuildRequires:  saxon
%endif
BuildRequires:  isorelax
BuildRequires:  relaxngDatatype
BuildRequires:  servletapi5
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xml-commons-resolver11
Obsoletes:      msv-strict < %{epoch}:%{version}-%{release}
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Sun Multi-Schema XML Validator (MSV) is a Java 
technology tool to validate XML documents against 
several kinds of XML schemata. It supports RELAX NG, 
RELAX Namespace, RELAX Core, TREX, XML DTDs, and a 
subset of XML Schema Part 1. This latest (version 1.2) 
release includes several bug fixes and adds better 
conformance to RELAX NG/W3C XML standards and JAXP 
masquerading. 

NOTE: This specific build of msv does not support
'crimson' (use xerces instead)

%package javadoc
Summary:        Javadoc for MSV proper
Group:          Development/Documentation
Obsoletes:      msv-strict-javadoc < %{epoch}:%{version}-%{release}
Provides:       msv-strict-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
%{summary}.

%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
Requires:       msv-msv
Requires:       msv-xsdlib

%description demo
%{summary}.

%package relames
Summary:        Relames 
Group:          Text Processing/Markup/XML
Requires:       isorelax
Requires:       jpackage-utils
Requires:       relaxngDatatype
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xml-commons-jaxp-1.3-apis
Requires:       xml-commons-resolver11
Requires:       msv-msv
Requires:       msv-xsdlib

%description relames
%{summary}.

%package relames-javadoc
Summary:        Javadoc for relames
Group:          Development/Documentation

%description relames-javadoc
%{summary}.

%package rngconv
Summary:        rngconv
Group:          Text Processing/Markup/XML
Requires:       isorelax
Requires:       jpackage-utils
Requires:       relaxngDatatype
Requires:       xerces-j2
Requires:       xml-commons-jaxp-1.3-apis
Requires:       msv-msv
Requires:       msv-xsdlib

%description rngconv
%{summary}.

%package xmlgen
Summary:        xmlgen
Group:          Text Processing/Markup/XML
Requires:       isorelax
Requires:       jpackage-utils
Requires:       relaxngDatatype
Requires:       xml-commons-jaxp-1.3-apis
Requires:       xerces-j2
Requires:       msv-msv
Requires:       msv-xsdlib

%description xmlgen
%{summary}.

%package xmlgen-javadoc
Summary:        Javadoc for xmlgen
Group:          Development/Documentation

%description xmlgen-javadoc
%{summary}.

%package xsdlib
Summary:        xsdlib
Group:          Text Processing/Markup/XML
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jpackage-utils
Requires:       relaxngDatatype
Obsoletes:      xsdlib < %{epoch}:%{version}-%{release}
Provides:       xsdlib = %{epoch}:%{version}-%{release}

%description xsdlib
%{summary}.

%package xsdlib-javadoc
Summary:        Javadoc for xsdlib
Group:          Development/Documentation
Obsoletes:      xsdlib-javadoc < %{epoch}:%{version}-%{release}
Provides:       xsdlib-javadoc = %{epoch}:%{version}-%{release}

%description xsdlib-javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{cvsversion}
# remove all binary libs
%{_bindir}/find -type f -name "*.jar" | %{_bindir}/xargs -t %{__rm}
# delete Class-Path: from manifests
for m in `%{_bindir}/find -type f -name MANIFEST.MF`; do
    sed -i -e '/^Class-[Pp]ath:/d' $m
done

for f in `%{_bindir}/find -type f -name copyright.txt`; do
    %{__mv} ${f} ${f}.orig
    %{_bindir}/iconv -f iso8859-1 -t utf8 -o ${f} ${f}.orig
    %{__rm} ${f}.orig
done

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav

pushd shared/lib
ln -s $(build-classpath ant) ant.jar
#ln -s $(build-classpath crimson) crimson.jar
#ln -s $(build-classpath dom4j) dom4j.jar
ln -s $(build-classpath isorelax) isorelax.jar
ln -s $(build-classpath junit) junit.jar
ln -s $(build-classpath relaxngDatatype) relaxngDatatype.jar
# FIXME The following doesn't seem to cause resolver to be found
ln -s $(build-classpath xml-commons-resolver11) resolver.jar
%if %without bootstrap
ln -s $(build-classpath jdom) jdom.jar
ln -s $(build-classpath saxon) saxon.jar
%endif
ln -s $(build-classpath servletapi5) servlet.jar
# FIXME The following doesn't seem to cause xalan to be found
ln -s $(build-classpath xalan-j2) xalan.jar
ln -s $(build-classpath xerces-j2) xercesImpl.jar
ln -s $(build-classpath xml-commons-jaxp-1.3-apis) xmlParserAPIs.jar
popd

%build
export CLASSPATH=$(%{_bindir}/build-classpath xalan-j2 xml-commons-resolver11)
export OPT_JAR_LIST=:
%{ant} -Dbuild.sysclasspath=first release

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}

install -p -m 644 package/msv.jar \
  %{buildroot}%{_javadir}/%{name}-%{version}.jar
(cd %{buildroot}%{_javadir} 
ln -s msv-%{version}.jar msv-msv-%{version}.jar
)
install -p -m 644 package/relames.jar \
  %{buildroot}%{_javadir}/%{name}-relames-%{version}.jar
install -p -m 644 package/rngconv.jar \
  %{buildroot}%{_javadir}/%{name}-rngconv-%{version}.jar
install -p -m 644 package/xmlgen.jar \
  %{buildroot}%{_javadir}/%{name}-xmlgen-%{version}.jar
install -p -m 644 package/xsdlib.jar \
  %{buildroot}%{_javadir}/%{name}-xsdlib-%{version}.jar
(cd %{buildroot}%{_javadir} 
ln -s msv-%{version}.jar msv-strict-%{version}.jar
ln -s msv-xsdlib-%{version}.jar xsdlib-%{version}.jar
)
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do ln -s ${jar} `echo $jar | sed "s|-%{version}||g"`; done)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 %{SOURCE1} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap msv msv %{cvsversion} JPP %{name}
install -p -m 644 %{SOURCE2} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-xsdlib.pom
%add_to_maven_depmap msv xsdlib %{cvsversion} JPP %{name}-xsdlib

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/msv
cp -pr msv/dist/javadoc/* \
                %{buildroot}%{_javadocdir}/%{name}-%{version}/msv
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/relames
cp -pr relames/dist/javadoc/* \
                %{buildroot}%{_javadocdir}/%{name}-%{version}/relames
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/xmlgen
cp -pr generator/dist/javadoc/* \
                %{buildroot}%{_javadocdir}/%{name}-%{version}/xmlgen
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/xsdlib
cp -pr xsdlib/dist/javadoc/* \
                %{buildroot}%{_javadocdir}/%{name}-%{version}/xsdlib
(cd %{buildroot}%{_javadocdir}
ln -s %{name}-%{version}/msv %{name}-msv
ln -s %{name}-%{version}/relames %{name}-relames
ln -s %{name}-%{version}/xsdlib %{name}-xsdlib
)

# docs
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{version}
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{version}/msv
install -p -m 644 msv/doc/* \
                  %{buildroot}%{_docdir}/%{name}-%{version}/msv
rm %{buildroot}%{_docdir}/%{name}-%{version}/msv/Apache-LICENSE-1.1.txt
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{version}/relames
install -p -m 644 relames/doc/* \
                  %{buildroot}%{_docdir}/%{name}-%{version}/relames
rm %{buildroot}%{_docdir}/%{name}-%{version}/relames/Apache-LICENSE-1.1.txt
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{version}/rngconv
install -p -m 644 rngconverter/doc/* \
                  %{buildroot}%{_docdir}/%{name}-%{version}/rngconv
rm %{buildroot}%{_docdir}/%{name}-%{version}/rngconv/Apache-LICENSE-1.1.txt
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{version}/xmlgen
install -p -m 644 generator/doc/* \
                  %{buildroot}%{_docdir}/%{name}-%{version}/xmlgen
rm %{buildroot}%{_docdir}/%{name}-%{version}/xmlgen/Apache-LICENSE-1.1.txt
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{version}/xsdlib
install -p -m 644 xsdlib/doc/* \
                  %{buildroot}%{_docdir}/%{name}-%{version}/xsdlib
rm %{buildroot}%{_docdir}/%{name}-%{version}/xsdlib/Apache-LICENSE-1.1.txt

#examples
install -d -m 755 %{buildroot}%{_datadir}/%{name}-%{version}/msv
cp -pr msv/dist/examples/* %{buildroot}%{_datadir}/%{name}-%{version}/msv
install -d -m 755 %{buildroot}%{_datadir}/%{name}-%{version}/xsdlib
cp -pr xsdlib/dist/examples/* %{buildroot}%{_datadir}/%{name}-%{version}/xsdlib

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%post
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif
%update_maven_depmap

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %dir %{_docdir}/%{name}-%{version}/msv
%doc %{_docdir}/%{name}-%{version}/msv/license.txt
%doc %{_docdir}/%{name}-%{version}/msv/copyright.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-msv-%{version}.jar
%{_javadir}/%{name}-msv.jar
%{_javadir}/msv-strict-%{version}.jar
%{_javadir}/msv-strict.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-msv*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/msv
%{_javadocdir}/%{name}-msv

%files demo
%defattr(0644,root,root,0755)
%dir %{_datadir}/%{name}-%{version}
%{_datadir}/%{name}-%{version}/msv
%{_datadir}/%{name}-%{version}/xsdlib

%files relames
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %dir %{_docdir}/%{name}-%{version}/relames
#%doc %{_docdir}/%{name}-%{version}/relames/license.txt
%doc %{_docdir}/%{name}-%{version}/relames/copyright.txt
%{_javadir}/%{name}-relames-%{version}.jar
%{_javadir}/%{name}-relames.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-relames*
%endif

%files relames-javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/relames
%{_javadocdir}/%{name}-relames

%files rngconv
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %dir %{_docdir}/%{name}-%{version}/rngconv
%doc %{_docdir}/%{name}-%{version}/rngconv/license.txt
%doc %{_docdir}/%{name}-%{version}/rngconv/copyright.txt
%{_javadir}/%{name}-rngconv-%{version}.jar
%{_javadir}/%{name}-rngconv.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-rngconv*
%endif

%files xmlgen
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %dir %{_docdir}/%{name}-%{version}/xmlgen
%doc %{_docdir}/%{name}-%{version}/xmlgen/license.txt
%doc %{_docdir}/%{name}-%{version}/xmlgen/copyright.txt
%{_javadir}/%{name}-xmlgen-%{version}.jar
%{_javadir}/%{name}-xmlgen.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-xmlgen*
%endif

%files xmlgen-javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/xmlgen

%files xsdlib
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %dir %{_docdir}/%{name}-%{version}/xsdlib
%doc %{_docdir}/%{name}-%{version}/xsdlib/license.txt
%doc %{_docdir}/%{name}-%{version}/xsdlib/copyright.txt
%{_javadir}/%{name}-xsdlib-%{version}.jar
%{_javadir}/%{name}-xsdlib.jar
%{_javadir}/xsdlib-%{version}.jar
%{_javadir}/xsdlib.jar
%{_datadir}/maven2/poms/JPP-%{name}-xsdlib.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-xsdlib*
%endif

%files xsdlib-javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/xsdlib
%{_javadocdir}/%{name}-xsdlib

%files manual
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %dir %{_docdir}/%{name}-%{version}/msv
%doc %dir %{_docdir}/%{name}-%{version}/relames
%doc %dir %{_docdir}/%{name}-%{version}/rngconv
%doc %dir %{_docdir}/%{name}-%{version}/xmlgen
%doc %dir %{_docdir}/%{name}-%{version}/xsdlib
%doc %{_docdir}/%{name}-%{version}/msv/ChangeLog.txt
%doc %{_docdir}/%{name}-%{version}/msv/*.html
%doc %{_docdir}/%{name}-%{version}/msv/*.gif
%doc %{_docdir}/%{name}-%{version}/msv/README.txt
%doc %{_docdir}/%{name}-%{version}/relames/README.txt
%doc %{_docdir}/%{name}-%{version}/rngconv/README.txt
%doc %{_docdir}/%{name}-%{version}/xmlgen/*.html
%doc %{_docdir}/%{name}-%{version}/xmlgen/README.txt
%doc %{_docdir}/%{name}-%{version}/xsdlib/*.html
%doc %{_docdir}/%{name}-%{version}/xsdlib/README.txt

%changelog
* Fri Oct 01 2010 David Walluck <dwalluck@redhat.com> 0:1.2-0.20050722.7
- add some jars to CLASSPATH
- own directories
- use %%doc
- use explict Obsoletes/Provides
- add poms
- really delete Class-Path from jar manifests

* Fri Jun 20 2008 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.6
- Rebuild for JPP 5.0

* Thu Aug 02 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.5jpp.ep1.1.2
- Rebuild

* Thu Jul 26 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.5jpp.ep1.1.1
- Rebuild with JDK 1.4

* Tue Jul 03 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.5jpp.ep1.1
- Merge with upstream
- Trick build into finding resolver and xalan by means of ant subpackages (FIXME)
- Patch out crimson reference

* Tue Jul 03 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.5jpp
- Patch to allow compilation with JDK 1.5

* Fri Mar 09 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.4jpp.ep1.1
- Merge with upstream

* Fri Mar 09 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.4jpp
- Create main msv package instead of msv-msv

* Mon Feb 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2-0.20050722.3jpp
- Add bootstrap option to build without saxon nor jdom
- Add gcj_support option

* Mon Feb 27 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.2jpp_1rh
- First Red Hat build

* Mon Feb 17 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2-0.20050722.2jpp
- First JPP 1.7 build

* Wed Aug 17 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2-0.20050722.1jpp
- First JPP from this code base
